<?php
namespace Test\Test\Controller;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * TestMasterController
 */
class TestMasterController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

    /**
     * testMasterRepository
     *
     * @var \Test\Test\Domain\Repository\TestMasterRepository
     * @inject
     */
    protected $testMasterRepository = NULL;
    
    /**
     * action listWrongJoin
     *
     * @return void
     */
    public function listWrongJoinAction()
    {
        $query = $this->testMasterRepository->createQuery();

        $query->matching(
            $query->equals('nontranslatedproperty', 'test')
        );

        $test = $query->execute();

    }
    
    /**
     * action listCorrectJoin
     *
     * @return void
     */
    public function listCorrectJoinAction()
    {

        $query = $this->testMasterRepository->createQuery();
        $querySettings = $query->getQuerySettings();
        $querySettings->setRespectSysLanguage(false);
        $query->setQuerySettings($querySettings);

        $query->matching(
            $query->logicalAnd(
                $query->logicalOr(
                    $query->in('sys_language_uid', [0, -1]),
                    $query->logicalAnd(
                        $query->equals('sys_language_uid', $querySettings->getLanguageUid()),
                        $query->equals('l10n_parent', 0)
                    )
                ),
                $query->equals('nontranslatedproperty', 'test')
            )
        );

        $test = $query->execute();

    }
    
    /**
     * action list
     *
     * @return void
     */
    public function listAction()
    {

    }

}